package com.huake.demo.common;

import com.huake.demo.dao.HeadMapper;
import com.huake.demo.entity.Dlx;
import com.huake.demo.entity.Dlxurl;
import com.huake.demo.entity.Head;
import com.huake.demo.entity.Heads;
import com.huake.demo.service.headService;
import com.huake.demo.service.headsService;
import io.netty.handler.codec.http.HttpHeaders;
import net.lightbody.bmp.BrowserMobProxy;
import net.lightbody.bmp.BrowserMobProxyServer;
import net.lightbody.bmp.client.ClientUtil;
import org.apache.log4j.Logger;
import org.openqa.selenium.By;
import org.openqa.selenium.JavascriptExecutor;
import org.openqa.selenium.Proxy;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.chrome.ChromeOptions;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.net.ssl.*;
import java.security.cert.X509Certificate;

@Component
public class MultiSiteLoginAutomation {

    private static final String CHROME_DRIVER_PATH = "D:\\sc\\chromedriver-win64\\chromedriver.exe"; // Chrome驱动路径
    private static final int WAIT_TIMEOUT = 10; // 等待超时设置
    private static final Logger logger = Logger.getLogger(MultiSiteLoginAutomation.class);
    
    @Autowired
    private headService headservice; // 注入服务

    @Autowired
    private headsService headsservice; // 注入服务

    public void runAutomation(Dlxurl dlxurl, Dlx dlx) throws InterruptedException {
        disableSSLVerification(); // 忽略SSL证书验证

        String[] urls = {dlxurl.getKyurl(), dlxurl.getHthurl(), dlxurl.getJyurl()}; // 要登录的URL
        String[] emails = {dlx.getKy(), dlx.getHth(), dlx.getJy()}; // 用户名
        String[] passwords = {"tg666888", "tg666888", "tg666888"}; // 密码

        for (int i = 0; i < 3; i++) { // 对每个网站进行登录
            BrowserMobProxy proxy = new BrowserMobProxyServer(); // 创建代理服务器
            proxy.start(0); // 启动代理
            Proxy seleniumProxy = ClientUtil.createSeleniumProxy(proxy); // 创建Selenium代理
            ChromeOptions options = new ChromeOptions(); // Chrome选项
            options.addArguments("--ignore-certificate-errors"); // 忽略证书错误
            options.setProxy(seleniumProxy); // 设置代理
            loginWithRetries(options, urls[i], emails[i], passwords[i], proxy,dlx.getUserId());
            proxy.stop(); // 停止代理
        }


    }

    private void loginWithRetries(ChromeOptions options, String url, String email, String password, BrowserMobProxy proxy,Integer userid) throws InterruptedException {
        WebDriver driver = initializeWebDriver(options); // 初始化WebDriver
        boolean loggedIn = false; // 登录状态

        proxy.newHar("login"); // 创建新的HAR文件

        // 添加请求过滤器
        proxy.addRequestFilter((request, contents, messageInfo) -> {
            String interceptedUrl = messageInfo.getUrl(); // 拦截到的请求URL
            if (interceptedUrl.contains("/agent/api/v1/front/getAgentDataVisualList")) {
                // 处理特定请求
                HttpHeaders headers = request.headers(); // 获取请求头
                update(email,headers,userid);
                logger.info("--------------------------------------开始--------------------------------------");
                logger.info("拦截到请求: " + interceptedUrl);
                logger.info("X-Api-Token: " + headers.get("X-Api-Token"));
                logger.info("X-Api-Uuid: " + headers.get("X-Api-Uuid"));
                logger.info("X-Api-Xxx: " + headers.get("X-Api-Xxx"));
                logger.info("--------------------------------------结束--------------------------------------");
            } else if (interceptedUrl.contains("/agent/api/v1/front/banner")) {
                // 处理其他逻辑
                HttpHeaders headers = request.headers();
                updates(email,headers,userid);
                // 获取请求头
                logger.info("--------------------------------------开始2--------------------------------------");
                logger.info("拦截到请求2: " + interceptedUrl);
                logger.info("X-Api-Token: " + headers.get("X-Api-Token"));
                logger.info("X-Api-Uuid: " + headers.get("X-Api-Uuid"));
                logger.info("X-Api-Xxx: " + headers.get("X-Api-Xxx"));
                logger.info("--------------------------------------结束--------------------------------------");
            }
            return null; // 继续请求
        });

        while (!loggedIn) { // 循环直到成功登录
            try {
                loggedIn = loginToSite(driver, url, email, password); // 尝试登录
            } catch (Exception e) {
                e.printStackTrace(); // 打印异常
            } finally {
                if (!loggedIn) { // 如果登录失败，重启WebDriver
                    driver.quit();
                    driver = initializeWebDriver(options);
                }
            }
        }
        Thread.sleep(3000);
        driver.quit(); // 退出WebDriver
    }

    //banner接口数据
    private void updates(String email, HttpHeaders headers, Integer userId) {
        try {
            Heads heads = new Heads(headers.get("X-Api-Token"), headers.get("X-Api-Uuid"), headers.get("X-Api-Xxx"), userId, email);
            headsservice.updateUser(heads);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    private void update(String email, HttpHeaders headers, Integer userId) {
        try {
            Head head = new Head(headers.get("X-Api-Token"), headers.get("X-Api-Uuid"), headers.get("X-Api-Xxx"), userId, email);
            headservice.updateUser(head);
        }catch (Exception e){
            e.printStackTrace();
        }

    }

    private WebDriver initializeWebDriver(ChromeOptions options) {
        System.setProperty("webdriver.chrome.driver", CHROME_DRIVER_PATH); // 设置Chrome驱动路径
        return new ChromeDriver(options); // 返回新实例
    }

    private boolean loginToSite(WebDriver driver, String url, String email, String password) throws InterruptedException {
        WebDriverWait wait = new WebDriverWait(driver, WAIT_TIMEOUT); // 初始化等待
        driver.get(url); // 访问登录页面

        // 使用显式等待获取验证码图片
        WebElement captchaImage = wait.until(ExpectedConditions.visibilityOfElementLocated(By.id("boxModle"))); // 等待并获取验证码图片
        String base64Captcha = CaptchaHandler.getBase64FromElement(driver, captchaImage); // 获取验证码
        String captchaCode = CaptchaHandler.sendCaptchaRequest(base64Captcha); // 发送验证码请求

        // 填写用户名、密码和验证码
        wait.until(ExpectedConditions.visibilityOfElementLocated(By.cssSelector("input.ant-input[placeholder='用户名']"))).sendKeys(email);
        wait.until(ExpectedConditions.visibilityOfElementLocated(By.cssSelector("input[type='password']"))).sendKeys(password);
        wait.until(ExpectedConditions.visibilityOfElementLocated(By.cssSelector("input.ant-input[placeholder='请输入验证码']"))).sendKeys(captchaCode);

        // 点击登录按钮
        WebElement finalLoginButton = wait.until(ExpectedConditions.elementToBeClickable(By.cssSelector("button.ant-btn.ant-btn-primary")));
        ((JavascriptExecutor) driver).executeScript("arguments[0].scrollIntoView(true);", finalLoginButton);
        ((JavascriptExecutor) driver).executeScript("arguments[0].click();", finalLoginButton);

        Thread.sleep(1500); // 等待页面加载

        try {
            wait.until(ExpectedConditions.urlContains("/app/home?showWelcome=false")); // 检查是否登录成功
            return true; // 登录成功
        } catch (Exception e) {
            logger.info("登录失败，重新尝试...");
            return false; // 登录失败
        }
    }

    private void disableSSLVerification() { // 禁用SSL验证
        try {
            TrustManager[] trustAllCerts = new TrustManager[]{
                    new X509TrustManager() {
                        public X509Certificate[] getAcceptedIssuers() {
                            return new X509Certificate[0];
                        }
                        public void checkClientTrusted(X509Certificate[] certs, String authType) {}
                        public void checkServerTrusted(X509Certificate[] certs, String authType) {}
                    }
            };

            SSLContext sc = SSLContext.getInstance("TLS");
            sc.init(null, trustAllCerts, new java.security.SecureRandom());
            HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
            HttpsURLConnection.setDefaultHostnameVerifier((hostname, session) -> true); // 允许所有主机
        } catch (Exception e) {
            e.printStackTrace(); // 打印异常
        }
    }
}
