package com.huake.demo.generator;

import org.mybatis.generator.api.MyBatisGenerator;
import org.mybatis.generator.config.*;
import org.mybatis.generator.exception.InvalidConfigurationException;
import org.mybatis.generator.internal.DefaultShellCallback;

import java.awt.*;
import java.io.File;
import java.io.IOException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

/**
 * MyBatis-Generator 代码生成工具
 * 根据数据库表可以自动构建JavaBean/*.XML文件
 * mysql生成的 ***mapper.xml需注意，可能需要手动处理(表名后面多个点 test..user)
 * oracle测试未发现问题
 * pg库未发现问题
 * @author long.yu
 * @date 2019-12-09
 * @mark 工具类
 */
public class MyBatisGeneratorUtil {
    public static void main(String[] args) throws IOException {
        Properties properties = new Properties();
        //配置数据库连接信息
//        properties.setProperty("driveClass","oracle.jdbc.OracleDriver");
//        properties.setProperty("url","jdbc:oracle:thin:localhost:1521:orcl");
//        properties.setProperty("userName","cim");
//        properties.setProperty("password","cim_123$");
//        //配置生成的包名和存放路径
//        properties.setProperty("package","com.huake.demo.pojo");
//        //设置生成路径
//        properties.setProperty("location","D:/resources/generator");
//        //设置表名
//        properties.setProperty("tableName","outline");
//        //设置数据库名称
//        properties.setProperty("schema","cim");

        properties.setProperty("driveClass","com.mysql.cj.jdbc.Driver");
        properties.setProperty("url","jdbc:mysql://154.208.207.2:3306/ky_bot?useUnicode=true&characterEncoding=utf-8&useSSL=false&serverTimezone=UTC&nullCatalogMeansCurrent=true&ignoreQualifiersAtRuntime=true");
        properties.setProperty("userName","ky_bot");
        properties.setProperty("password","LK6NScKBzMP75n74");
        //配置生成的包名和存放路径
        properties.setProperty("package","com.huake.demo");
        //设置生成路径
        properties.setProperty("location","D:/sc");
        //设置表名
        properties.setProperty("tableName","heads");
        //设置数据库名称
        properties.setProperty("schema","ky_bot");

        List warnings = new ArrayList<String>();
        boolean overwrite = true;
        Configuration configuration = new Configuration();
        Context context = new Context(ModelType.CONDITIONAL);
        context.setTargetRuntime("MyBatis3Simple");
        context.setId("simple");
        //自动识别数据库关键字，默认false，如果设置为true，
        //根据SqlReservedWords中定义的关键字列表；一般保留默认值，遇到数据库关键字（Java关键字），
        //使用columnOverride覆盖
        context.addProperty("autoDelimitKeywords","true");
        //生成的Java文件的编码
        context.addProperty("javaFileEncoding","utf-8");
        context.addProperty("beginningDelimiter","`");
        context.addProperty("endingDelimiter","`");
        //格式化java代码
        context.addProperty("javaFormatter","org.mybatis.generator.api.dom.DefaultJavaFormatter");
        //格式化xml代码
        context.addProperty("xmlFormatter","org.mybatis.generator.api.dom.DefaultXmlFormatter");

        //格式化信息
        PluginConfiguration pluginConfiguration = new PluginConfiguration();
        pluginConfiguration.setConfigurationType("org.mybatis.generator.plugins.SerializablePlugin");
        pluginConfiguration.setConfigurationType("org.mybatis.generator.plugins.ToStringPlugin");
        context.addPluginConfiguration(pluginConfiguration);



        //设置是否生成注释
        CommentGeneratorConfiguration commentGeneratorConfiguration = new CommentGeneratorConfiguration();
        commentGeneratorConfiguration.addProperty("suppressAllComments","true");
        commentGeneratorConfiguration.addProperty("suppressDate","true");
        context.setCommentGeneratorConfiguration(commentGeneratorConfiguration);

        //设置连接数据库
        JDBCConnectionConfiguration jdbcConnectionConfiguration = new JDBCConnectionConfiguration();
        jdbcConnectionConfiguration.setDriverClass(properties.getProperty("driveClass"));
        jdbcConnectionConfiguration.setConnectionURL(properties.getProperty("url"));
        jdbcConnectionConfiguration.setPassword(properties.getProperty("password"));
        jdbcConnectionConfiguration.setUserId(properties.getProperty("userName"));
        context.setJdbcConnectionConfiguration(jdbcConnectionConfiguration);


        JavaTypeResolverConfiguration javaTypeResolverConfiguration = new JavaTypeResolverConfiguration();
        //是否使用bigDecimal， false可自动转化以下类型（Long, Integer, Short, etc.）
        javaTypeResolverConfiguration.addProperty("forceBigDecimals","false");
        context.setJavaTypeResolverConfiguration(javaTypeResolverConfiguration);


        //生成实体类的地址
        JavaModelGeneratorConfiguration javaModelGeneratorConfiguration = new JavaModelGeneratorConfiguration();
        javaModelGeneratorConfiguration.setTargetPackage(properties.getProperty("package"));
        javaModelGeneratorConfiguration.setTargetProject(properties.getProperty("location"));
        javaModelGeneratorConfiguration.addProperty("enableSubPackages","false");
        javaModelGeneratorConfiguration.addProperty("trimStrings","true");
        context.setJavaModelGeneratorConfiguration(javaModelGeneratorConfiguration);

        //生成的xml的地址
        SqlMapGeneratorConfiguration sqlMapGeneratorConfiguration = new SqlMapGeneratorConfiguration();
        sqlMapGeneratorConfiguration.setTargetProject(properties.getProperty("location"));
        sqlMapGeneratorConfiguration.setTargetPackage("mappers");
        sqlMapGeneratorConfiguration.addProperty("enableSubPackages","false");
        context.setSqlMapGeneratorConfiguration(sqlMapGeneratorConfiguration);

        //dao
        JavaClientGeneratorConfiguration javaClientGeneratorConfiguration = new JavaClientGeneratorConfiguration();
        javaClientGeneratorConfiguration.setTargetPackage(properties.getProperty("package"));
        javaClientGeneratorConfiguration.setTargetProject(properties.getProperty("location"));
        javaClientGeneratorConfiguration.setConfigurationType("XMLMAPPER");
        javaClientGeneratorConfiguration.addProperty("enableSubPackages","false");
        context.setJavaClientGeneratorConfiguration(javaClientGeneratorConfiguration);


        TableConfiguration tableConfiguration = new TableConfiguration(context);
        tableConfiguration.setTableName(properties.getProperty("tableName"));
        tableConfiguration.setCountByExampleStatementEnabled(true);
        tableConfiguration.setUpdateByExampleStatementEnabled(true);
        tableConfiguration.setDeleteByExampleStatementEnabled(true);
        tableConfiguration.setInsertStatementEnabled(true);
        tableConfiguration.setDeleteByPrimaryKeyStatementEnabled(true);
        tableConfiguration.setSchema(properties.getProperty("schema"));
//        tableConfiguration.setCatalog(properties.getProperty("schema"));
//        GeneratedKey generatedKey=new GeneratedKey("id","MySql",true,null);
//        tableConfiguration.setGeneratedKey(generatedKey);
        context.addTableConfiguration(tableConfiguration);

        configuration.addContext(context);

        DefaultShellCallback callback = new DefaultShellCallback(overwrite);
        try{
            MyBatisGenerator myBatisGenerator = new MyBatisGenerator(configuration, callback, warnings);
            myBatisGenerator.generate(null);
        }catch (IOException ie){
            ie.printStackTrace();
        }catch (InterruptedException ite){
            ite.printStackTrace();
        }catch (SQLException se){
            System.err.println("SQL语句异常！");
            se.printStackTrace();
        }catch (InvalidConfigurationException ive){
            System.err.println("配置信息存在无效数据！");
            ive.printStackTrace();
        }finally {
            Desktop.getDesktop().open(new File("D:/sc"));
        }

    }
}
