package com.huake.demo;

import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;

public class HttpClientHelper {

    public static String sendPostRequest(String url, String json) {
        try (CloseableHttpClient httpClient = HttpClients.createDefault()) {
            HttpPost post = new HttpPost(url);
            post.setHeader("Content-Type", "application/json");
            post.setEntity(new StringEntity(json));

            try (CloseableHttpResponse response = httpClient.execute(post)) {
                String responseBody = EntityUtils.toString(response.getEntity());
                return responseBody;
            }
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public static String extractCaptchaResult(String responseBody) throws JSONException {
        JSONObject jsonObject = new JSONObject(responseBody);
        if (jsonObject.getBoolean("success")) {
            return jsonObject.getJSONObject("data").getString("result");
        } else {
            System.err.println("请求失败: " + jsonObject.getString("message"));
            return "";
        }
    }
}
